---
title: Contact Picker API
slug: Web/API/Contact_Picker_API
tags:
  - API
  - Contact Picker API
  - Contacts
  - Landing
  - Overview
  - PWA
  - contact picker
---
<div>{{draft}}{{securecontext_header}}{{DefaultAPISidebar("Contact Picker API")}}</div>

<p class="summary">The Contact Picker API allows users to select entries from their contact list and share limited details of the selected entries with a website or application.</p>

<div class="notecard note">
<p><strong>Note:</strong> This API is <em>not available</em> in <a href="/en-US/docs/Web/API/Web_Workers_API">Web Workers</a> (not exposed via {{domxref("WorkerNavigator")}}).</p>
</div>

<div class="note">
<p>The Contact Picker API should not be confused with the deprecated <a href="/docs/Archive/B2G_OS/API/Contacts_API">Contact API</a>.</p>
</div>

<h2 id="Contact_Picker_API_Concepts_and_Usage">Contact Picker API Concepts and Usage</h2>

<p>Access to contacts has long been a feature available within native applications. The Contacts Picker API brings that functionality to web applications.</p>

<p>Use cases include selecting contacts to message via an email or chat application, selecting a contacts phone number for use with voice over IP (VOIP), or for discovering contacts who have already joined a social platform. User agents can also offer a consistent experience with other applications on a users device.</p>

<p>When calling the {{domxref('ContactsManager.select', 'select')}} method of the {{domxref('ContactsManager')}} interface, the user is presented with a contact picker, whereby they can then select contact information to share with the web application. User interaction is required before permission to display the contact picker is granted and access to contacts is not persistent; the user must grant access every time a request is made by the application.</p>

<p>This API is only available from a secure top-level browsing context and very carefully considers the sensitivity and privacy of contact data. The onus is on the user for choosing data to share and only allows specific data for selected contacts, with no access to any data for other contacts.</p>

<h2 id="Interfaces">Interfaces</h2>

<dl>
 <dt>{{domxref("ContactsManager")}}</dt>
 <dd>The <strong><code>ContactsManager</code></strong> interface provides a way for users to select and share limited details of contacts with a web application.</dd>
 <dt>{{domxref("Navigator.contacts")}}</dt>
 <dd>Returns a {{domxref("ContactsManager")}} object instance, from which all other functionality can be accessed.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<h3 id="Feature_Detection">Feature Detection</h3>

<p>The following code checks whether the Contact Picker API is supported.</p>

<pre class="brush: js notranslate">const supported = ('contacts' in navigator &amp;&amp; 'ContactsManager' in window);
</pre>

<h3 id="Checking_for_Supported_Properties">Checking for Supported Properties</h3>

<p>The following asynchronous function uses the <code>getProperties()</code> method to check for supported properties.</p>

<pre class="brush: js notranslate">async function checkProperties() {
  const supportedProperties = await navigator.contacts.getProperties();
  if (supportedProperties.includes('name')) {
    // run code for name support
  }
  if (supportedProperties.includes('email')) {
    // run code for email support
  }
  if (supportedProperties.includes('tel')) {
    // run code for telephone number support
  }
  if (supportedProperties.includes('address')) {
    // run code for address support
  }
  if (supportedProperties.includes('icon')) {
    // run code for avatar support
  }
}
</pre>

<h3 id="Selecting_Contacts">Selecting Contacts</h3>

<p>The following example sets an array of properties to be retrieved for each contact, as well as setting an options object to allow for multiple contacts to be selected.</p>

<p>An asynchronous function is then defined which uses the <code>select()</code> method to present the user with a contact picker interface and handle the chosen results.</p>

<pre class="brush: js notranslate">const props = ['name', 'email', 'tel', 'address', 'icon'];
const opts = {multiple: true};

async function getContacts() {
  try {
      const contacts = await navigator.contacts.select(props, opts);
      handleResults(contacts);
  } catch (ex) {
      // Handle any errors here.
  }
}</pre>

<p><code>handleResults()</code> is a developer defined function.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Contact Picker API')}}</td>
   <td>{{Spec2('Contact Picker API')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.ContactsManager")}}</p>

<h2 id="See_also">See also:</h2>

<ul>
 <li><a href="https://web.dev/contact-picker/">A Contact Picker for the Web</a></li>
 <li><a href="https://contact-picker.glitch.me/">A Contact Picker demo on glitch</a></li>
</ul>
